package proxy.soap;

import java.net.MalformedURLException;
import java.net.URL;
import java.util.Vector;

import org.apache.soap.Constants;
import org.apache.soap.Fault;
import org.apache.soap.Header;
import org.apache.soap.SOAPException;
import org.apache.soap.encoding.SOAPMappingRegistry;
import org.apache.soap.rpc.Call;
import org.apache.soap.rpc.Parameter;
import org.apache.soap.rpc.Response;
import org.apache.soap.transport.http.SOAPHTTPConnection;
import org.w3c.dom.Node;

import com.ibm.gre.engine.util.XMLUtil;

public class LoginManagerEJBProxy
{
  private Call call;
  private URL url = null;
  private String stringURL = "http://localhost:9080/IRMWebServices/servlet/rpcrouter";
  private java.lang.reflect.Method setTcpNoDelayMethod;
	
	private String clientControllerEJBKey = null;
	private String userControllerEJBKey = null;
	
  public LoginManagerEJBProxy()
  {
    try
    {
      setTcpNoDelayMethod = SOAPHTTPConnection.class.getMethod("setTcpNoDelay", new Class[]{Boolean.class});
    }
    catch (Exception e)
    {
    }
  }

  public synchronized void setEndPoint(URL url)
  {
    this.url = url;
  }

  public synchronized URL getEndPoint() throws MalformedURLException
  {
    return getURL();
  }

  private URL getURL() throws MalformedURLException
  {
    if (url == null && stringURL != null && stringURL.length() > 0)
    {
      url = new URL(stringURL);
    }
    return url;
  }

  public synchronized java.lang.String integrationLogin(java.lang.String username,java.lang.String password,java.lang.String datasource,java.lang.String host) throws Exception
  {
    call = createCall();
    String targetObjectURI = "http://ibm.com/com.ibm.gre.engine.ejb.facade.LoginManagerEJB";
    String SOAPActionURI = "";

    if(getURL() == null)
    {
      throw new SOAPException(Constants.FAULT_CODE_CLIENT,
      "A URL must be specified via LoginManagerEJBProxy.setEndPoint(URL).");
    }

    call.setMethodName("integrationLogin");
    call.setEncodingStyleURI(Constants.NS_URI_SOAP_ENC);
    call.setTargetObjectURI(targetObjectURI);
    Vector params = new Vector();
    Parameter usernameParam = new Parameter("username", java.lang.String.class, username, Constants.NS_URI_SOAP_ENC);
    params.addElement(usernameParam);
    Parameter passwordParam = new Parameter("password", java.lang.String.class, password, Constants.NS_URI_SOAP_ENC);
    params.addElement(passwordParam);
    Parameter datasourceParam = new Parameter("datasource", java.lang.String.class, datasource, Constants.NS_URI_SOAP_ENC);
    params.addElement(datasourceParam);
    Parameter hostParam = new Parameter("host", java.lang.String.class, host, Constants.NS_URI_SOAP_ENC);
    params.addElement(hostParam);
    Parameter langParam = new Parameter("languageCode", java.lang.String.class, "en", Constants.NS_URI_SOAP_ENC);
    params.addElement(langParam);
    call.setParams(params);
    Response resp = call.invoke(getURL(), SOAPActionURI);

	System.out.println("after login");
    //Check the response.
    if (resp.generatedFault())
    {
      Fault fault = resp.getFault();
      call.setFullTargetObjectURI(targetObjectURI);
      throw new SOAPException(fault.getFaultCode(), fault.getFaultString());
    }
    else
    {
      Parameter refValue = resp.getReturnValue();
      clientControllerEJBKey = (java.lang.String)refValue.getValue();
      return clientControllerEJBKey;
    }
  }

  public synchronized java.lang.String getDataSourceList() throws Exception
  {
    call = createCall();
    String targetObjectURI = "http://ibm.com/com.ibm.gre.engine.ejb.facade.LoginManagerEJB";
    String SOAPActionURI = "";

    if(getURL() == null)
    {
      throw new SOAPException(Constants.FAULT_CODE_CLIENT,
      "A URL must be specified via LoginManagerEJBProxy.setEndPoint(URL).");
    }

    call.setMethodName("getDataSourceList");
    call.setEncodingStyleURI(Constants.NS_URI_SOAP_ENC);
    call.setTargetObjectURI(targetObjectURI);
    Vector params = new Vector();
    call.setParams(params);
    Response resp = call.invoke(getURL(), SOAPActionURI);

    //Check the response.
    if (resp.generatedFault())
    {
      Fault fault = resp.getFault();
      call.setFullTargetObjectURI(targetObjectURI);
      throw new SOAPException(fault.getFaultCode(), fault.getFaultString());
    }
    else
    {
      Parameter refValue = resp.getReturnValue();
      return ((java.lang.String)refValue.getValue());
    }
  }
  
  public synchronized java.lang.String getUserController() throws Exception
  {
    call = createCall();
    String targetObjectURI = "http://ibm.com/com.ibm.gre.engine.ejb.facade.ClientControllerEJB";
    String SOAPActionURI = "";

    if(getURL() == null)
    {
      throw new SOAPException(Constants.FAULT_CODE_CLIENT,
      "A URL must be specified via LoginManagerEJBProxy.setEndPoint(URL).");
    }
    Header header = new Header();
    Vector vector = new Vector();
   	Node node = XMLUtil.createDocument().createElement("EJBKey");
    XMLUtil.setValue(node,clientControllerEJBKey);
    vector.add(node);
    header.setHeaderEntries(vector);
    call.setHeader(header);
    
    call.setMethodName("getUserControllerAsString");
    call.setEncodingStyleURI(Constants.NS_URI_SOAP_ENC);
    call.setTargetObjectURI(targetObjectURI);
    Response resp = call.invoke(getURL(), SOAPActionURI);

    //Check the response.
    if (resp.generatedFault())
    {
      Fault fault = resp.getFault();
      call.setFullTargetObjectURI(targetObjectURI);
      throw new SOAPException(fault.getFaultCode(), fault.getFaultString());
    }
    else
    {
      Parameter refValue = resp.getReturnValue();
      userControllerEJBKey = (String)refValue.getValue();
      return userControllerEJBKey;
    }
  }
  
  public synchronized java.lang.String getUserList() throws Exception
  {
    call = createCall();
    String targetObjectURI = "http://ibm.com/com.ibm.gre.engine.ejb.facade.UserControllerEJB";
    String SOAPActionURI = "";

    if(getURL() == null)
    {
      throw new SOAPException(Constants.FAULT_CODE_CLIENT,
      "A URL must be specified via LoginManagerEJBProxy.setEndPoint(URL).");
    }

    Header header = new Header();
    Vector vector = new Vector();
   	Node node = XMLUtil.createDocument().createElement("EJBKey");
    XMLUtil.setValue(node,userControllerEJBKey);
    vector.add(node);
    header.setHeaderEntries(vector);
    call.setHeader(header);
    
    call.setMethodName("getUserList");
    call.setEncodingStyleURI(Constants.NS_URI_SOAP_ENC);
    call.setTargetObjectURI(targetObjectURI);
    Vector params = new Vector();     
    Parameter hostParam = new Parameter("hostId", Long.class, new Long(0), Constants.NS_URI_SOAP_ENC);    
    params.addElement(hostParam);  
    Parameter blockParam = new Parameter("blockStart", Integer.class, new Integer(0), Constants.NS_URI_SOAP_ENC);    
    params.addElement(blockParam);  
    Parameter sizeParam = new Parameter("blockSize", Integer.class, new Integer(0), Constants.NS_URI_SOAP_ENC);    
    params.addElement(sizeParam);  
    Parameter sourceParam = new Parameter("source", Integer.class,  new Integer(0), Constants.NS_URI_SOAP_ENC);    
    params.addElement(sourceParam);  
    call.setParams(params);
    Response resp = call.invoke(getURL(), SOAPActionURI);

    //Check the response.
    if (resp.generatedFault())
    {
      Fault fault = resp.getFault();
      call.setFullTargetObjectURI(targetObjectURI);
      throw new SOAPException(fault.getFaultCode(), fault.getFaultString());
    }
    else
    {
      Parameter refValue = resp.getReturnValue();
      return ((java.lang.String)refValue.getValue());
    }
  }
  
 
  
  public synchronized java.lang.String getGroupList() throws Exception
  {
    call = createCall();
    String targetObjectURI = "http://ibm.com/com.ibm.gre.engine.ejb.facade.UserControllerEJB";
    String SOAPActionURI = "";

    if(getURL() == null)
    {
      throw new SOAPException(Constants.FAULT_CODE_CLIENT,
      "A URL must be specified via LoginManagerEJBProxy.setEndPoint(URL).");
    }
    
    Header header = new Header();
    Vector vector = new Vector();
   	Node node = XMLUtil.createDocument().createElement("EJBKey");
    XMLUtil.setValue(node,userControllerEJBKey);
    vector.add(node);
    header.setHeaderEntries(vector);
    call.setHeader(header);
    
    call.setMethodName("getGroupList");
    call.setEncodingStyleURI(Constants.NS_URI_SOAP_ENC);
    call.setTargetObjectURI(targetObjectURI);
    Vector params = new Vector();
    Parameter hostParam = new Parameter("hostId", Long.class, new Long(0), Constants.NS_URI_SOAP_ENC);    
    params.addElement(hostParam);  
    Parameter blockParam = new Parameter("blockStart", Integer.class, new Integer(0), Constants.NS_URI_SOAP_ENC);    
    params.addElement(blockParam);  
    Parameter sizeParam = new Parameter("blockSize", Integer.class, new Integer(0), Constants.NS_URI_SOAP_ENC);    
    params.addElement(sizeParam);  
    Parameter sourceParam = new Parameter("source", Integer.class,  new Integer(0), Constants.NS_URI_SOAP_ENC);    
    params.addElement(sourceParam);  
    call.setParams(params);
    Response resp = call.invoke(getURL(), SOAPActionURI);

    //Check the response.
    if (resp.generatedFault())
    {
      Fault fault = resp.getFault();
      call.setFullTargetObjectURI(targetObjectURI);
      throw new SOAPException(fault.getFaultCode(), fault.getFaultString());
    }
    else
    {
      Parameter refValue = resp.getReturnValue();
      return ((java.lang.String)refValue.getValue());
    }
  }

  public synchronized java.lang.String getVersion() throws Exception
  {
    call = createCall();
    String targetObjectURI = "http://ibm.com/com.ibm.gre.engine.ejb.facade.LoginManagerEJB";
    String SOAPActionURI = "";

    if(getURL() == null)
    {
      throw new SOAPException(Constants.FAULT_CODE_CLIENT,
      "A URL must be specified via LoginManagerEJBProxy.setEndPoint(URL).");
    }

    call.setMethodName("getVersion");
    call.setEncodingStyleURI(Constants.NS_URI_SOAP_ENC);
    call.setTargetObjectURI(targetObjectURI);
    Vector params = new Vector();
    call.setParams(params);
    Response resp = call.invoke(getURL(), SOAPActionURI);

    //Check the response.
    if (resp.generatedFault())
    {
      Fault fault = resp.getFault();
      call.setFullTargetObjectURI(targetObjectURI);
      throw new SOAPException(fault.getFaultCode(), fault.getFaultString());
    }
    else
    {
      Parameter refValue = resp.getReturnValue();
      return ((java.lang.String)refValue.getValue());
    }
  }

  protected Call createCall()
  {
    SOAPHTTPConnection soapHTTPConnection = new SOAPHTTPConnection();
    if ( setTcpNoDelayMethod != null)
    {
      try
      {
        setTcpNoDelayMethod.invoke(soapHTTPConnection, new Object[]{Boolean.TRUE});
      }
      catch (Exception ex)
      {
      }
    }
    Call call = new Call();
    call.setSOAPTransport(soapHTTPConnection);
    SOAPMappingRegistry smr = call.getSOAPMappingRegistry();
    return call;
  }
}
