<?xml version="1.0" encoding="UTF-8"?>

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0" xmlns:fo="http://www.w3.org/1999/XSL/Format">

	<xsl:template match="/">
		<fo:root xmlns:fo="http://www.w3.org/1999/XSL/Format">

			<!-- defines page layout -->
			<fo:layout-master-set>
				<fo:simple-page-master master-name="simple" page-width="21cm" page-height="27.9cm" margin-top="0.5cm" margin-bottom="0.5cm" margin-left="0.5cm" margin-right="0.5cm">
					<fo:region-body />
				</fo:simple-page-master>
			</fo:layout-master-set>


			<!-- defines the content -->
			<fo:page-sequence master-reference="simple">

				<fo:flow flow-name="xsl-region-body">
					<fo:block font-size="16pt" font-family="Courier" font-weight="bold" line-height="26pt" space-after.optimum="12pt" text-align="center">
					<xsl:value-of select="//MetaData/List/Item[1]/@FlPlnCmpntDefNm"/> Report
					</fo:block>
				
					<fo:table border-top="solid black" border-bottom="solid black" border-left="solid black" border-right="solid black" font-size="6.5pt">
						<xsl:variable name="width" select="19 div count(//MetaData/List/Item)"/>
						
						<!-- Column width setting  -->
						<xsl:for-each select="//MetaData/List/Item">
						<fo:table-column>
							<xsl:attribute name="column-width">
								<xsl:value-of select="$width"/>
								<xsl:text>cm</xsl:text> 
							</xsl:attribute>
						</fo:table-column>
						</xsl:for-each>

						<fo:table-header>

						
							<fo:table-row>
								<xsl:apply-templates select="//MetaData"/>
							</fo:table-row>													
						</fo:table-header>

						<!-- Records -->
						<fo:table-body>
							<xsl:for-each select="//Data/List/Item">

									<fo:table-row>
										
										<xsl:variable name="pos" select="position()" />										
										<xsl:for-each select="//MetaData/List/Item">

										<xsl:variable name="colName" select="@FlPlnCmpntAttrDefColNm" />


											<fo:table-cell border-right="solid black" padding="2pt">
												<fo:block text-align="start">
													<xsl:value-of select="//Data/List/Item[position()=$pos]/@*[name()=$colName]" />
												</fo:block>
											</fo:table-cell>
											
										</xsl:for-each>
										
									</fo:table-row>

							</xsl:for-each>
						</fo:table-body>
					</fo:table>

				</fo:flow>
			</fo:page-sequence>
		</fo:root>
	</xsl:template>

	<xsl:template match="//MetaData">
		<xsl:for-each select="List/Item">
			<fo:table-cell border-top="solid black" border-bottom="solid black" border-right="solid black" padding="3pt">
				<fo:block>
				<xsl:value-of select="@FlPlnCmpntAttrDefCapt"/>
				</fo:block>
			</fo:table-cell>
		</xsl:for-each>	
	
	</xsl:template>

</xsl:stylesheet>